diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 952756601..a3b0048bf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1382,8 +1384,7 @@ public final class Blocks {
         }
     }
 
-    @Nullable
-    public static Block<?> getBlock(int id)
+    public static @Nullable Block<?> getBlock(int id)
     {
         if (id < 0 || id >= Blocks.blocksList.length) {
             return null;
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
index 9207fcd0e..f5b700143 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
@@ -36,16 +36,16 @@ public class FluidLava
             final int data = world.getBlockData(tilePos) & 0x0F;
             if (data == 0) {
                 if (world.dimension == Dimension.NETHER) {
-                    world.setBlockIdNotify(tilePos, Blocks.COBBLE_NETHERRACK_IGNEOUS.id());
+                    world.setBlockTypeNotify(tilePos, Blocks.COBBLE_NETHERRACK_IGNEOUS);
                 } else {
-                    world.setBlockIdNotify(tilePos, Blocks.OBSIDIAN.id());
+                    world.setBlockTypeNotify(tilePos, Blocks.OBSIDIAN);
                 }
             } else if (data <= 2) {
-                world.setBlockIdNotify(tilePos, Blocks.COBBLE_GRANITE.id());
+                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_GRANITE);
             } else if (data <= 4) {
-                world.setBlockIdNotify(tilePos, Blocks.COBBLE_STONE.id());
+                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_STONE);
             } else {
-                world.setBlockIdNotify(tilePos, Blocks.COBBLE_BASALT.id());
+                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_BASALT);
             }
             BlockLogicFluid.fizz(world, tilePos);
         }
@@ -65,21 +65,23 @@ public class FluidLava
             p.x += rand.nextInt(3) - 1;
             p.y++;
             p.z += rand.nextInt(3) - 1;
-            final int id = world.getBlockId(p);
-            if (id == 0) {
-                if (isFlammable(world, p.west(queryPos)) ||
-                    isFlammable(world, p.east(queryPos)) ||
-                    isFlammable(world, p.north(queryPos)) ||
-                    isFlammable(world, p.south(queryPos)) ||
-                    isFlammable(world, p.down(queryPos)) ||
-                    isFlammable(world, p.up(queryPos))) {
-                    world.setBlockIdNotify(p, Blocks.FIRE.id());
+            if (world.areBlocksLoaded(p, 2)) {
+                final @NotNull Block<?> block = world.getBlockType(p);
+                if (block == Blocks.AIR) {
+                    if (isFlammable(world, p.west(queryPos)) ||
+                        isFlammable(world, p.east(queryPos)) ||
+                        isFlammable(world, p.north(queryPos)) ||
+                        isFlammable(world, p.south(queryPos)) ||
+                        isFlammable(world, p.down(queryPos)) ||
+                        isFlammable(world, p.up(queryPos))) {
+                        world.setBlockTypeNotify(p, Blocks.FIRE);
+                        return;
+                    }
+                    continue;
+                }
+                if (block.getMaterial().blocksMotion()) {
                     return;
                 }
-                continue;
-            }
-            if (Blocks.blocksList[id].getMaterial().blocksMotion()) {
-                return;
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
index b54916f82..c82b7cd1b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
@@ -40,7 +40,7 @@ public class FluidWater
         if (encountered == Materials.LAVA) {
             final int data = world.getBlockData(tilePos) & 0x0F;
             if (data == 0) {
-                world.setBlockIdNotify(tilePos, Blocks.COBBLE_LIMESTONE.id());
+                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_LIMESTONE);
                 BlockLogicFluid.fizz(world, tilePos);
             }
         }
@@ -68,10 +68,7 @@ public class FluidWater
 
     @Override
     public void onFlowIntoBlock(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final int meta) {
-        final Block<?> b = world.getBlock(tilePos);
-        if (b != null) {
-            b.dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-        }
+        world.getBlockType(tilePos).dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 3ba382720..b4b797808 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -138,8 +138,7 @@ public class TileEntityMobSpawner extends TileEntity {
         for (tilePos.x = this.x -r; tilePos.x <= this.x + r; tilePos.x++) {
             for (tilePos.y = this.y -r; tilePos.y <= this.y + r; tilePos.y++) {
                 for (tilePos.z = this.z -r; tilePos.z <= this.z + r; tilePos.z++) {
-                    int id = this.worldObj.getBlockId(tilePos);
-                    if (id == Blocks.MOBSPAWNER.id()) {
+                    if (this.worldObj.getBlockType(tilePos) == Blocks.MOBSPAWNER) {
                         count++;
                     }
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 0e49e289b..88cecea89 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -111,7 +111,7 @@ public class BlockLogicPistonBase extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         checkIfExtend(world, tilePos);
     }
 
@@ -204,12 +204,12 @@ public class BlockLogicPistonBase extends BlockLogic {
             if (!moving.isExtending()) {
                 moving.finalTick();
             } else {
-                world.setBlockId(shiftedPos, 0);
+                world.setBlockType(shiftedPos, Blocks.AIR);
             }
         }
-        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), direction.getId());
-        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(this.block.id(), direction.getId(), null, direction, false, true));
-        world.setBlockIdNotify(shiftedPos, 0);
+        world.setBlockTypeData(tilePos, Blocks.PISTON_MOVING, direction.getId());
+        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(this.block, direction.getId(), null, direction, false, true));
+        world.setBlockTypeNotify(shiftedPos, Blocks.AIR);
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
     }
 
@@ -251,9 +251,7 @@ public class BlockLogicPistonBase extends BlockLogic {
         return (data & MASK_POWERED) != 0;
     }
 
-    protected boolean isPushable(int id, @NotNull World world, @NotNull TilePos tilePos, boolean canDestroy) {
-        Block<?> block = Blocks.getBlock(id);
-        if (block == null) return false;
+    protected boolean isPushable(final @NotNull Block<?> block, @NotNull World world, @NotNull TilePos tilePos, boolean canDestroy) {
         int pushReaction = block.getPistonPushReaction(world, tilePos);
         return !block.hasTag(BlockTags.PISTON_CRUSHING) &&
             !block.getImmovable() &&
@@ -280,17 +278,17 @@ public class BlockLogicPistonBase extends BlockLogic {
             if (posO.y < 0 || posO.y >= world.getHeightBlocks()) {
                 return false;
             }
-            int id = world.getBlockId(posO);
-            if (id == 0) {
+            final @NotNull Block<?> block = world.getBlockType(posO);
+            if (block == Blocks.AIR) {
                 break;
             }
-            if (!isPushable(id, world, posO, true)) {
-                if (blocks == 1 && BlockTags.PISTON_CRUSHING.appliesTo(Blocks.getBlock(id)) && tryCrush(world, tilePos, direction)) {
+            if (!isPushable(block, world, posO, true)) {
+                if (blocks == 1 && block.hasTag(BlockTags.PISTON_CRUSHING) && tryCrush(world, tilePos, direction)) {
                     break;
                 }
                 return false;
             }
-            if (Blocks.blocksList[id].getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
+            if (block.getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
                 break;
             }
             if (blocks == maxPushedBlocks) {
@@ -306,11 +304,10 @@ public class BlockLogicPistonBase extends BlockLogic {
 
     public boolean tryCrush(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
         TilePos pos2 = tilePos.add(direction, new TilePos());
-        Block<?> block = world.getBlock(pos2);
-        if (block == null) return true;
-        world.playBlockEvent(null, pos2, LevelListener.EVENT_BLOCK_BREAK, world.getBlockId(pos2));
+        Block<?> block = world.getBlockType(pos2);
+        world.playBlockEvent(null, pos2, LevelListener.EVENT_BLOCK_BREAK, world.getBlockType(pos2).id());
         block.dropWithCause(world, EnumDropCause.SILK_TOUCH, pos2, world.getBlockData(pos2), null, null);
-        world.setBlockIdNotify(pos2, 0);
+        world.setBlockTypeNotify(pos2, Blocks.AIR);
         return true;
     }
 
@@ -325,15 +322,15 @@ public class BlockLogicPistonBase extends BlockLogic {
             if (posO.y < 0 || posO.y >= world.getHeightBlocks()) {
                 return false;
             }
-            int blockId = world.getBlockId(posO);
-            if (blockId == 0) {
+            final @NotNull Block<?> block = world.getBlockType(posO);
+            if (block == Blocks.AIR) {
                 break;
             }
-            if (!isPushable(blockId, world, posO, true)) {
+            if (!isPushable(block, world, posO, true)) {
                 return false;
             }
-            if (Blocks.blocksList[blockId].getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
-                Blocks.blocksList[blockId].dropWithCause(world, EnumDropCause.WORLD, posO, world.getBlockData(posO), world.getTileEntity(posO), null);
+            if (block.getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
+                block.dropWithCause(world, EnumDropCause.WORLD, posO, world.getBlockData(posO), world.getTileEntity(posO), null);
                 break;
             }
             if (blocks == maxPushedBlocks) {
@@ -347,33 +344,33 @@ public class BlockLogicPistonBase extends BlockLogic {
         TilePos posP = new TilePos(posO);
         while (!posO.equals(tilePos)) {
             posP.set(posO.x - direction.getOffsetX(), posO.y - direction.getOffsetY(), posO.z - direction.getOffsetZ());
-            int pushId = world.getBlockId(posP);
+            @NotNull Block<?> pushBlock = world.getBlockType(posP);
             int pushMeta = world.getBlockData(posP);
             TileEntity pushEntity = world.getTileEntity(posP);
             if (pushEntity instanceof TileEntityMovingPistonBlock && posP.equals(tilePos)) {
                 break;
             }
-            if (pushId == this.block.id() && posP.equals(tilePos)) {
+            if (pushBlock == this.block && posP.equals(tilePos)) {
                 createPistonHeadAt(world, posO, data, direction);
-            } else if (pushId == Blocks.PISTON_MOVING.id()) {
+            } else if (pushBlock == Blocks.PISTON_MOVING) {
                 TileEntity old = world.getTileEntity(posP);
                 if (old instanceof TileEntityMovingPistonBlock moving) {
                     if (!moving.isSourcePiston()) {
-                        pushId = moving.getMovedId();
+                        pushBlock = moving.getMovedBlock();
                         pushMeta = moving.getMovedData();
                         pushEntity = moving.getMovedEntity();
                     }
                 }
                 world.removeTileEntity(posP);
-                world.setBlockIdData(posO, Blocks.PISTON_MOVING.id(), pushMeta);
-                world.replaceTileEntity(posO, BlockLogicPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+                world.setBlockTypeData(posO, Blocks.PISTON_MOVING, pushMeta);
+                world.replaceTileEntity(posO, BlockLogicPistonMoving.createTileEntity(pushBlock, pushMeta, pushEntity, direction, true, false));
             } else {
                 world.removeTileEntity(posP);
-                world.setBlockIdData(posO, Blocks.PISTON_MOVING.id(), pushMeta);
-                world.replaceTileEntity(posO, BlockLogicPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+                world.setBlockTypeData(posO, Blocks.PISTON_MOVING, pushMeta);
+                world.replaceTileEntity(posO, BlockLogicPistonMoving.createTileEntity(pushBlock, pushMeta, pushEntity, direction, true, false));
             }
             if (!posP.equals(tilePos)) {
-                world.setBlockIdDataRaw(posP, 0, 0);
+                world.setBlockTypeRaw(posP, Blocks.AIR);
             }
             posO.set(posP.x, posP.y, posP.z);
         }
@@ -382,8 +379,8 @@ public class BlockLogicPistonBase extends BlockLogic {
     }
 
     public void createPistonHeadAt(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()));
-        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()), null, direction, true, false));
+        world.setBlockTypeData(tilePos, Blocks.PISTON_MOVING, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()));
+        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()), null, direction, true, false));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
index a71f8ae16..6a9281cf1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
@@ -61,18 +61,18 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
             if (posO.y < 0 || posO.y >= world.getHeightBlocks()) {
                 return false;
             }
-            int id = world.getBlockId(posO);
-            if (id == 0) {
+            final @NotNull Block<?> block = world.getBlockType(posO);
+            if (block == Blocks.AIR) {
                 break;
             }
-            if (!isPushable(id, world, posO, true)) {
-                if (blocks == 1 && BlockTags.PISTON_CRUSHING.appliesTo(Blocks.getBlock(id)) && tryCrush(world, tilePos, direction)) {
+            if (!isPushable(block, world, posO, true)) {
+                if (blocks == 1 && block.hasTag(BlockTags.PISTON_CRUSHING) && tryCrush(world, tilePos, direction)) {
                     didCrush = true;
                     break;
                 }
                 return false;
             }
-            if (Blocks.blocksList[id].getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
+            if (block.getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
                 break;
             }
             if (blocks == maxPushedBlocks) {
@@ -85,12 +85,12 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
         }
         if (!didCrush && blocks == 1) { // Block Flinging
             tilePos.add(direction, posO);
-            Block<?> block = world.getBlock(posO);
+            Block<?> block = world.getBlockType(posO);
             if (block == null) return true;
             int blockMeta = world.getBlockData(posO);
             TileEntity tileEntity = world.getTileEntity(posO);
             world.removeTileEntity(posO);
-            world.setBlockIdNotify(posO, 0);
+            world.setBlockTypeNotify(posO, Blocks.AIR);
             if (!world.isClientSide) {
                 EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, posO.x + 0.5, posO.y + 0.5, posO.z + 0.5, block.id(), blockMeta, tileEntity);
                 entityFallingBlock.hasRemovedBlock = true;
@@ -111,11 +111,10 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
     @Override
     public boolean tryCrush(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
         TilePos pos2 = tilePos.add(direction, new TilePos());
-        Block<?> block = world.getBlock(pos2);
-        if (block == null) return true;
-        world.playBlockEvent(null, pos2, LevelListener.EVENT_BLOCK_BREAK, world.getBlockId(pos2));
+        Block<?> block = world.getBlockType(pos2);
+        world.playBlockEvent(null, pos2, LevelListener.EVENT_BLOCK_BREAK, world.getBlockType(pos2).id());
         block.dropWithCause(world, EnumDropCause.PISTON_CRUSH, pos2, world.getBlockData(pos2), null, null);
-        world.setBlockIdNotify(pos2, 0);
+        world.setBlockTypeNotify(pos2, Blocks.AIR);
         return true;
     }
 
@@ -132,15 +131,15 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
                 if (posO.y < 0 || posO.y >= world.getHeightBlocks()) {
                     return false;
                 }
-                int blockId = world.getBlockId(posO);
-                if (blockId == 0) {
+                final @NotNull Block<?> block = world.getBlockType(posO);
+                if (block == Blocks.AIR) {
                     break;
                 }
-                if (!isPushable(blockId, world, posO, true)) {
+                if (!isPushable(block, world, posO, true)) {
                     return false;
                 }
-                if (Blocks.blocksList[blockId].getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
-                    Blocks.blocksList[blockId].dropWithCause(world, EnumDropCause.WORLD, posO, world.getBlockData(posO), world.getTileEntity(posO), null);
+                if (block.getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
+                    block.dropWithCause(world, EnumDropCause.WORLD, posO, world.getBlockData(posO), world.getTileEntity(posO), null);
                     break;
                 }
                 if (blocks == maxPushedBlocks) {
@@ -155,16 +154,16 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
                 TilePos posP = new TilePos(posO);
                 while (!posO.equals(tilePos)) {
                     posP.set(posO.x - direction.getOffsetX(), posO.y - direction.getOffsetY(), posO.z - direction.getOffsetZ());
-                    int pushId = world.getBlockId(posP);
+                    @NotNull Block<?> pushBlock = world.getBlockType(posP);
                     TileEntity pushEntity = world.getTileEntity(posP);
                     if (pushEntity instanceof TileEntityMovingPistonBlock && posP.equals(tilePos)) {
                         break;
                     }
-                    if (pushId == this.block.id() && posP.equals(tilePos)) {
+                    if (pushBlock == this.block && posP.equals(tilePos)) {
                         createPistonHeadAt(world, posO, data, direction);
                     }
                     if (!posP.equals(tilePos))
-                        world.setBlockIdDataRaw(posP, 0, 0);
+                        world.setBlockTypeRaw(posP, Blocks.AIR);
                     posO.x = posP.x;
                     posO.y = posP.y;
                     posO.z = posP.z;
@@ -191,8 +190,8 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
 
     @Override
     public void createPistonHeadAt(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()));
-        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD_STEEL.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()), null, direction, true, false));
+        world.setBlockTypeData(tilePos, Blocks.PISTON_MOVING, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()));
+        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD_STEEL, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()), null, direction, true, false));
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
index 55368869b..890266124 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
@@ -11,6 +11,8 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.Objects;
+
 public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
     public BlockLogicPistonBaseSticky(@NotNull Block<?> block, int maxPushedBlocks) {
         super(block, maxPushedBlocks);
@@ -24,51 +26,50 @@ public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
             if (!moving.isExtending()) {
                 moving.finalTick();
             } else {
-                world.setBlockId(posDir, 0);
+                world.setBlockType(posDir, Blocks.AIR);
             }
         }
-        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), direction.getId());
-        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(this.block.id(), direction.getId(), null, direction, false, true));
+        world.setBlockTypeData(tilePos, Blocks.PISTON_MOVING, direction.getId());
+        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(this.block, direction.getId(), null, direction, false, true));
         TilePos pos1 = new TilePos(tilePos.x() + direction.getOffsetX() * 2, tilePos.y() + direction.getOffsetY() * 2, tilePos.z() + direction.getOffsetZ() * 2);
-        int retractId = world.getBlockId(pos1);
+        @NotNull Block<?> retractBlock = world.getBlockType(pos1);
         int retactMeta = world.getBlockData(pos1);
         TileEntity retractEntity = world.getTileEntity(pos1);
         boolean pulledMoving = false;
-        if (retractId == Blocks.PISTON_MOVING.id()) {
+        if (retractBlock == Blocks.PISTON_MOVING) {
             if ((world.getTileEntity(pos1) instanceof TileEntityMovingPistonBlock movingPistonBlock)) {
                 if (movingPistonBlock.getDirection() == direction && movingPistonBlock.isExtending()) {
                     movingPistonBlock.finalTick();
-                    retractId = movingPistonBlock.getMovedId();
+                    retractBlock = movingPistonBlock.getMovedBlock();
                     retactMeta = movingPistonBlock.getMovedData();
                     retractEntity = movingPistonBlock.getMovedEntity();
                     pulledMoving = true;
                 }
             }
         }
-        Block<?> retractedBlock = Blocks.getBlock(retractId);
         TilePos pos2 = new TilePos(tilePos);
-        if (!pulledMoving && retractedBlock != null &&
-            isPushable(retractId, world, pos1, false) &&
-            (retractedBlock.getPistonPushReaction(world, pos1) == Material.PISTON_PUSHABLE || (retractedBlock.getLogic() instanceof BlockLogicPistonBase))) {
+        if (!pulledMoving &&
+            isPushable(retractBlock, world, pos1, false) &&
+            (retractBlock.getPistonPushReaction(world, pos1) == Material.PISTON_PUSHABLE || (retractBlock.getLogic() instanceof BlockLogicPistonBase))) {
             if (!(retractEntity instanceof TileEntityMovingPistonBlock)) {
                 world.removeTileEntity(pos1);
             }
-            world.setBlockId(pos1, 0);
+            world.setBlockType(pos1, Blocks.AIR);
             pos2.x += direction.getOffsetX();
             pos2.y += direction.getOffsetY();
             pos2.z += direction.getOffsetZ();
-            world.setBlockIdData(pos2, Blocks.PISTON_MOVING.id(), retactMeta);
-            world.replaceTileEntity(pos2, BlockLogicPistonMoving.createTileEntity(retractId, retactMeta, retractEntity, direction, false, false));
-            world.notifyBlockChange(pos1, 0);
+            world.setBlockTypeData(pos2, Blocks.PISTON_MOVING, retactMeta);
+            world.replaceTileEntity(pos2, BlockLogicPistonMoving.createTileEntity(retractBlock, retactMeta, retractEntity, direction, false, false));
+            world.notifyBlockChange(pos1, Blocks.AIR);
         } else if (!pulledMoving) {
-            world.setBlockIdNotify(posDir, 0);
+            world.setBlockTypeNotify(posDir, Blocks.AIR);
         }
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) pos2.x + 0.5D, (double) pos2.y + 0.5D, (double) pos2.z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
     }
 
     @Override
     public void createPistonHeadAt(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()));
-        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()), null, direction, true, false));
+        world.setBlockTypeData(tilePos, Blocks.PISTON_MOVING, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()));
+        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()), null, direction, true, false));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index e2c470172..a1ee5acc8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -50,12 +50,12 @@ public class BlockLogicPistonHead extends BlockLogic {
         }
         Direction orientation = direction.getOpposite();
         TilePos nextPos = tilePos.add(orientation, new TilePos());
-        Block<?> block = world.getBlock(nextPos);
+        Block<?> block = world.getBlockType(nextPos);
         if (block != null && block.getLogic() instanceof BlockLogicPistonBase) {
             int data2 = world.getBlockData(nextPos);
             if (BlockLogicPistonBase.isPowered(data2)) {
                 block.dropWithCause(world, EnumDropCause.PROPER_TOOL, nextPos, data2, null, null);
-                world.setBlockIdNotify(nextPos, 0);
+                world.setBlockTypeNotify(nextPos, Blocks.AIR);
             }
         }
     }
@@ -131,17 +131,17 @@ public class BlockLogicPistonHead extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         Direction direction = getDirectionFromMeta(world.getBlockData(tilePos));
         if (direction == Direction.NONE) {
             return;
         }
         TilePos posOffset = tilePos.sub(direction, new TilePos());
-        Block<?> block = world.getBlock(posOffset);
-        if (block != null && block.getLogic() instanceof BlockLogicPistonBase) {
-            block.onNeighborChanged(world, posOffset, id);
+        Block<?> offsetBlock = world.getBlockType(posOffset);
+        if (offsetBlock.getLogic() instanceof BlockLogicPistonBase) {
+            offsetBlock.onNeighborChanged(world, posOffset, block);
         } else {
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
